%define         _hardened_build 1

Summary: DjVu viewers, encoders, and utilities
Name: djvulibre
Version: 3.5.28
Release: 1%{?dist}
License: GPLv2+
URL: http://djvu.sourceforge.net/
Source0: https://git.opencloudos.tech/sources-stream/djvulibre/djvulibre-3.5.28.tar.gz/sha512/db3b8a5b56d700e911be32057f721a2a597e6f52e6fade203ad75ad76ab2d8facff2e474fd18beea703ccd5fa6425352e619a8fda40e69add1724dbee26050c6/%{name}-%{version}.tar.gz
Patch0001: djvulibre-3.5.22-cdefs.patch
Patch0002: djvulibre-3.5.27-export-file.patch
Patch0003: djvulibre-3.5.27-check-image-size.patch
Patch0004: djvulibre-3.5.27-integer-overflow.patch
Patch0005: djvulibre-3.5.27-check-input-pool.patch
Patch0006: djvulibre-3.5.27-djvuport-stack-overflow.patch
Patch0007: djvulibre-3.5.27-unsigned-short-overflow.patch
Patch0008: djvulibre-3.5.27-out-of-bound-write-2.patch

Requires(post): xdg-utils
Requires(preun): xdg-utils


BuildRequires:  gcc
BuildRequires: libjpeg-turbo-devel


BuildRequires: libtiff-devel
BuildRequires: xdg-utils chrpath
BuildRequires: hicolor-icon-theme
# BuildRequires: inkscape
BuildRequires: gcc-c++ make

Provides: %{name}-mozplugin = %{version}
Obsoletes: %{name}-mozplugin < 3.5.24

%description
DjVu is a web-centric format and software platform for distributing documents
and images. DjVu can advantageously replace PDF, PS, TIFF, JPEG, and GIF for
distributing scanned documents, digital documents, or high-resolution pictures.
DjVu content downloads faster, displays and renders faster, looks nicer on a
screen, and consume less client resources than competing formats. DjVu images
display instantly and can be smoothly zoomed and panned with no lengthy
re-rendering.

DjVuLibre is a free (GPL'ed) implementation of DjVu, including viewers,
decoders, simple encoders, and utilities. The browser plugin is in its own
separate sub-package.


%package libs
Summary: Library files for DjVuLibre

%description libs
Library files for DjVuLibre.


%package devel
Summary: Development files for DjVuLibre
Requires: %{name}-libs = %{version}-%{release}
Requires: pkgconfig

%description devel
Development files for DjVuLibre.


%prep
%setup -q 
%patch0001 -p1 -b .cdefs
%patch0002 -p1 -b .export-file
%patch0003 -p1 -b .check-image-size
%patch0004 -p1 -b .integer-overflow
%patch0005 -p1 -b .check-input-pool
%patch0006 -p1 -b .djvuport-stack-overflow
%patch0007 -p1 -b .unsigned-short-overflow
%patch0008 -p1 -b .out-of-bound-write-2


%build 
%configure --with-qt=%{_libdir}/qt-3.3 --enable-threads

make %{?_smp_mflags} V=1


%install
make install DESTDIR=%{buildroot}

# Fix for the libs to get stripped correctly (still required in 3.5.20-2)
find %{buildroot}%{_libdir} -name '*.so*' | xargs %{__chmod} +x

# Remove rpath
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvutoxml
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvused
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/cjb2
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/csepdjvu
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvuserve
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvm
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvuxmlparser
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvutxt
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/ddjvu
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvumake
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/cpaldjvu
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvuextract
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/c44
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvups
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvudump
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/djvmcvt
chrpath --delete $RPM_BUILD_ROOT%{_bindir}/bzz

# This XML file does not differentiate between DjVu Image and DjVu Document
rm -f $RPM_BUILD_ROOT%{_datadir}/mime/packages/djvulibre-mime.xml

pushd desktopfiles
for i in 22 32 48 64 ; do
    install -d $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/${i}x${i}/mimetypes/
    cp -a ./prebuilt-hi${i}-djvu.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/${i}x${i}/mimetypes/image-vnd.djvu.mime.png
done
popd


%post
rm -f %{_datadir}/applications/djvulibre-djview3.desktop || :
rm -f %{_datadir}/icons/hicolor/32x32/apps/djvulibre-djview3.png || :


%preun
if [ $1 -eq 0 ]; then
    %{_datadir}/djvu/osi/desktop/register-djvu-mime uninstall || :
fi


%ldconfig_scriptlets libs


%files
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/djvu/
%{_datadir}/icons/hicolor/16x16/mimetypes/*
%{_datadir}/icons/hicolor/20x20/mimetypes/*
%{_datadir}/icons/hicolor/22x22/mimetypes/*
%{_datadir}/icons/hicolor/24x24/mimetypes/*
%{_datadir}/icons/hicolor/32x32/mimetypes/*
%{_datadir}/icons/hicolor/48x48/mimetypes/*
%{_datadir}/icons/hicolor/64x64/mimetypes/*
%{_datadir}/icons/hicolor/72x72/mimetypes/*
%{_datadir}/icons/hicolor/96x96/mimetypes/*
%{_datadir}/icons/hicolor/128x128/mimetypes/*
%{_datadir}/icons/hicolor/scalable/mimetypes/*
%{_datadir}/icons/hicolor/256x256/mimetypes/*


%files libs
%doc README COPYRIGHT COPYING NEWS
%{_libdir}/*.so.*


%files devel
%doc doc/*.*
%{_includedir}/libdjvu/
%{_libdir}/pkgconfig/ddjvuapi.pc
%exclude %{_libdir}/*.la
%{_libdir}/*.so


%changelog
* Tue Apr 30 2024 jiang ling yu <1353859743@qq.com> - 3.5.28-1
- other
- initial build
